StructuredBuffer< float4x4> sbWorld;

cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : LAYERVIEWPROJECTION;
	float4x4 tW : WORLD;
	float4 color <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
};


struct VS_IN
{
	uint ii : SV_InstanceID;
	float4 PosO : POSITION;

};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;	
};

vs2ps VS(VS_IN input)
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;
	
	float4x4 w = sbWorld[input.ii];
	w=mul(w,tW);
    Out.PosWVP  = mul(input.PosO,mul(w,tVP));
    return Out;
}


float4 PS_Tex(vs2ps In): SV_Target
{
    return color;
}


technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_Tex() ) );
	}
}




